#!/usr/bin/perl
# recoveres imap folders lost during the previous imapd update.
#

# invoke input
open( SLOC, "/usr/bin/locate mailboxlist |" ) || die "$!";

while( <SLOC> )  {
   #skip the new imap scheme users
   next if ( /^(.*)\/mail\/.mailboxlist$/  );

   #find old imap scheme user
   if( /^\/home\/sites\/(.*)\/users\/(.*)\/.mailboxlist$/  )  {
      $user = $2;
      $vsite = $1;
      $target = "/home/sites/".$vsite."/users/".$user;

      if ( ! -e "$target/mail/.mailboxlist" )  {
         if ( ! -e "$target/mail" )  {
            # create new mail directory
            mkdir( "$target/mail", 0300 ) || die "$!"; 
         }
         # apply new imap perms policy
         chmod 02700, "$target/mail";
         system("/bin/chown $user.$vsite $target/mail");

         # create new mailbox list
         system("/bin/touch $target/mail/.mailboxlist");
         chmod 0644, "$target/mail/.mailboxlist";
         system("/bin/chown $user.$vsite $target/mail/.mailboxlist");
      }
      # recover old folders to new mail/folders
      move_imap_folders( $user, $vsite, $target );

      # notify recovery via email?
      # any legal hoochie coochie?
   }
}


sub move_imap_folders  { 
   # assume that ~/user/mail and ~/user/mail/.mailboxlist
   local( $user, $vsite, $target ) = @_;

   open MBLIST, "$target/.mailboxlist"
     || die "$!";
   while ( $folder = <MBLIST> )  {
      chop $folder;
      if( -e "$target/$folder" )  {
         # backup existing recovered folders
         if( -e "$target/mail/$folder" )  {
            $nufolder = $folder."-rec";
            system("/bin/mv $target/$folder $target/mail/$nufolder");
            # don't forget ownership and permissions.
            chmod 0600, "$target/mail/$nufolder";
            $folder = $nufolder;
         }
         else  {
            system("/bin/mv $target/$folder $target/mail");
         }


         # update new mailbox list
         open NUMBLIST, ">> $target/mail/.mailboxlist" || die "$!";
         print NUMBLIST "$folder\n";
         close NUMBLIST;
      }
   }
   close MBLIST;

   # backup the original mailbox list
   system("/bin/mv $target/.mailboxlist $target/mail/.mailboxlist-rec");

   # update mailbox files' ownership (new imap policy)
   system("/bin/chown $user.$vsite $target/mail/*");
}
