#!/usr/bin/perl

# author: Kevin K.M. Chiu
#       Cobalt Networks
# version: 2.0
# date: 7-4-99
#
# Copyright 1999-2000, Cobalt Networks, Inc
# All rights reserved

use Cobalt::Product;
use Cobalt::Locale;
use Cobalt::swatch;
use Cobalt::Util;

use strict;
use CGI;
use Locale::gettext;

my $locale=Cobalt::Locale->getByHTTPHeader( $ENV{ 'HTTP_ACCEPT_LANGUAGE' } );

my $q=new CGI;
my $service = $q->param('service');

my (@s,$title);
if ($service eq "email") {
    @s = ('pop3', 'imap', 'smtp');
    $title = MSG_get_ui("swatch_service_title_email");
} else {
    push @s, $service;
    $title = MSG_get_ui("swatch_service_title_" . $service);
}

my ($help,$jhelp,$defcon,$message,$body,$serv,$ball,$t,$since);
foreach $serv (@s) {
    $since = swatch_get_modify("service", $serv);
    $t = MSG_get_ui("swatch_service_title_" . $serv);
    $jhelp = $serv . "statusHelp";
    $help .= "var $jhelp=\'" . MSG_get_ui("swatch_service_help", $t) . "\';\n";
    $defcon = swatch_get_defcon("service", $serv);
    $defcon = ($defcon) ? ($defcon) : "0";
    $ball = $defcon_images{ $defcon };
    $message = MSG_get_ui("swatch_service_body_defcon_$defcon", $t, $since);

    $body .= <<END;
<TR>
    <TD WIDTH="26">
	<CENTER><A HREF="javascript: top.showInfo( $jhelp );" onMouseOver="status='[str.help]'; top.showInfo( $jhelp ); return true;"><IMG SRC="/.cobalt/images/smallest_help_but.gif" ALIGN="BOTTOM" BORDER="0"></A></CENTER>
    </TD>
    <TD WIDTH="25">
        <P ALIGN="CENTER">$ball
    </TD>
    <TD WIDTH="449"><FONT COLOR="#FFFFFF">&nbsp;</FONT>
        $message
    </TD>
</TR>
END
}

# Read in the template
open( TEMPLATE, "$Template_dir/service.tmpl" )
    || die "Cannot read $Template_dir/service.tmpl: $!\n";

print "content-type: text/html\nCache-Control: no-cache\n\n";

while ( <TEMPLATE> ) {
    s/\[HELP\]/$help/o;
    s/\[TITLE\]/$title/o;
    s/\[BODY\]/$body/o;

    s/\[str.([^\]]+)\]/Locale::gettext::dgettext("ui", "$1")/geo;

    print;
}

close TEMPLATE;


1;
