#!/usr/bin/perl

# author: Kevin K.M. Chiu
# version: 2.0
# date: 07-01-99
#
# Copyright 1998-1999, Cobalt Networks, Inc
# All rights reserved

use Cobalt::Product;
use Cobalt::List;
use Cobalt::User;

#use strict;
use CGI;

# global variables
my $q=new CGI;


my $listName=$q->param( 'listname' );
my $group=$q->param( 'group' );

my $mailListListScriptPath="$AdminCGIs_dir/mailListList/mailListList.cgi";
my $forbiddenURL="/.cobalt/error/forbidden.html";

# force login
my $loginName=$ENV{ REMOTE_USER };
unless (user_authok($loginName, "group", $group)) {
    print "location: $forbiddenURL\n\n";
    die "Unauthorised access by $loginName, not a member of $group.\n";
} 

handleMailListDelPage();
1;


#
# event handler for delete mailing list page
#
sub handleMailListDelPage {
    my $err=0;
    my $info='<IMG SRC="/.cobalt/images/bang.gif" ALIGN=CENTER>';

    # remove mailing list
    my $fqdn = (Cobalt::Vsite::vsite_get_bygroup($group))[1];
    my $ret=list_delete($group, $fqdn, $listName);
    if( $ret!~/^2/ ) {
	$info.=substr( $ret, 4 ).'<BR>';
	$err=1;
    }

    if( $err ) {
	# generate error message
	$ENV{ PARAM_GROUP }=$group;
	$ENV{ PARAM_INFO }=$info;
	require $mailListListScriptPath;
	delete $ENV{ PARAM_GROUP };
	delete $ENV{ PARAM_INFO };
    }
    else {
	# generate new mailing list list
	$ENV{ PARAM_GROUP }=$group;
	require $mailListListScriptPath;
	delete $ENV{ PARAM_GROUP };
    }
}
