#!/usr/bin/perl

# author: Kevin K.M. Chiu
# version: 2.0
# date: 07-01-99
#
# Copyright 1998-1999, Cobalt Networks, Inc
# All rights reserved

use Cobalt::Product;
use Cobalt::Locale;
use Cobalt::List;
use Cobalt::User;

# use strict;
use Locale::gettext;

use CGI;
my $q=new CGI;

my $locale=Cobalt::Locale->getByHTTPHeader( $ENV{ 'HTTP_ACCEPT_LANGUAGE' } );
if( $locale ) { $ENV{ 'LANGUAGE' }=$locale->getLocale(); }

my $forbiddenURL="/.cobalt/error/forbidden.html";

my $group;
my $info;
if( $ENV{ PARAM_GROUP } || $ENV{ PARAM_INFO } ) {
    $group=$ENV{ PARAM_GROUP };
    $info=$ENV{ PARAM_INFO };
}
else {
    use CGI;
    my $q=new CGI;

    $group=$q->param( 'group' );
    $info=$q->param( 'info' );
    my $user = $ENV{REMOTE_USER};
    unless (user_authok($user, "group", $group)) {
	print "location: $forbiddenURL\n\n";
	die "Unauthorised access by $user, not a member of $group.\n";
    } 
}

# global variables
my $mailListAddScriptURL="/cgi-bin/.cobalt/mailListAdd/mailListAdd.cgi";
my $mailListModScriptURL="/cgi-bin/.cobalt/mailListMod/mailListMod.cgi";
my $mailListDelScriptURL="/cgi-bin/.cobalt/mailListDel/mailListDel.cgi";

# get a list of mailing lists
my $fqdn = (Cobalt::Vsite::vsite_get_bygroup($group))[1];
my @mailLists = list_lists($group, $fqdn);
if ($mailLists[0] =~ /^[134]\S*\s/) {
    # substr( $mailLists[0], 5 ).'<BR>';
    @mailLists = ();
}

# only displays if >=13 mailing lists
my $buttons='';
if( $#mailLists>=13 ) {
    my $addMailList=eval("\"".Locale::gettext::dgettext("ui", "addMailList")."\"");
    $buttons=<<END;
<A HREF="$mailListAddScriptURL?group=$group" onMouseOver="status='$addMailList'; return true;"><IMG SRC="/.cobalt/images/add_mail_list_but.gif" BORDER=0></A>
END
}

# print mailing lists
my $mailListTable;
my $i;
for( $i=0; $i<=$#mailLists; $i++ ) {
    my $listName=$mailLists[$i];
    my @members=list_get_mem($group, $fqdn, $listName);
    if ($members[0] =~ /^[134]\S*\s/) {
	# substr( $members[0], 5 ).'<BR>';
	@members = ();
    }
    map { $_ =~ s/\@${fqdn}//; } @members;

    my $deletable='true';
    my $deleteIcon='/.cobalt/images/delete.gif';
    my $recipients=join ', ', sort @members;

    my $modifyMailListX=eval("\"".Locale::gettext::dgettext("ui", "modifyMailListX")."\"");
    my $removeMailList=eval("\"".Locale::gettext::dgettext("ui", "removeMailList")."\"");

    $mailListTable.=<<END;
<TR>
  <TD BGCOLOR="#FFFFFF"><FONT COLOR=#FFFFFF>&nbsp;</FONT>$listName</TD>
  <TD BGCOLOR="#FFFFFF"><FONT COLOR=#FFFFFF>&nbsp;</FONT>$recipients</TD>
  <TD NOWRAP BGCOLOR="#FFFFFF"><CENTER>
    <A HREF="javascript: modify( '$listName' );" onMouseOver="status='$modifyMailListX'; return true;"><IMG SRC="/.cobalt/images/modify.gif" ALT="$modifyMailListX" BORDER="0"></A><FONT COLOR=#FFFFFF>&nbsp;</FONT><A HREF="javascript: del( '$listName', $deletable );" onMouseOver="status='$removeMailList'; return true;"><IMG SRC="$deleteIcon" ALT="$removeMailList" BORDER="0"></A>
  </CENTER></TD>
</TR>
END
}

my $hideTitleStart='';
my $hideTitleEnd='';
if( $#mailLists<0 ) {
    # if no mailing list
    $mailListTable="<TR><TD COLSPAN=3><FONT COLOR=#FFFFFF>&nbsp;</FONT><I>".eval("\"".Locale::gettext::dgettext("ui", "noMailLists")."\"")."</I></TD></TR>";
    $hideTitleStart='<!-- ';
    $hideTitleEnd=' -->';
}

# Read in the template
open( TEMPLATE, "$Template_dir/mailListList.tmpl" )
    || die "Cannot read $Template_dir/mailListList.tmpl: $!\n";

print "content-type: text/html\nCache-Control: no-cache\n\n";

while( <TEMPLATE> ) {
    s/\[BUTTONS\]/$buttons/o;
    s/\[GROUP\]/$group/;
    s/\[HIDETITLESTART\]/$hideTitleStart/o;
    s/\[HIDETITLEEND\]/$hideTitleEnd/o;
    s/\[MAILLIST_TABLE\]/$mailListTable/;
    s/\[MAILLISTADDSCRIPTURL\]/$mailListAddScriptURL/o;
    s/\[MAILLISTDELSCRIPTURL\]/$mailListDelScriptURL/o;
    s/\[MAILLISTMODSCRIPTURL\]/$mailListModScriptURL/o;
    s/\[USER_INFO\]/$info/o;

    s/\[str.([^\]]+)\]/Locale::gettext::dgettext("ui", "$1")/geo;

    print;
}
close TEMPLATE;

1;
