#!/usr/bin/perl

# author: Kevin K.M. Chiu
#       Cobalt Networks
# version: 3.0
# date: 8-17-98
#
# Version 2.0 uses Monitor.pm instead of AlertDB.pm
#
# Copyright 1998-1999, Cobalt Networks, Inc
# All rights reserved

use Cobalt::Product;
use Cobalt::Locale;
use Cobalt::Meta;
use Cobalt::Util;
use Cobalt::swatch;

use strict;
use CGI;

# global variables
my $alertScriptURL='/cgi-bin/.cobalt/alert/alert.cgi';

my $q=new CGI;

my $locale=Cobalt::Locale->getByHTTPHeader($ENV{'HTTP_ACCEPT_LANGUAGE'});
my ($obj,$defcon,$ball,$msgkey,$message,$info,$back);

$obj=Cobalt::Meta->create("type" => "memory");
$obj->retrieve("memory");
$defcon = swatch_get_defcon("memory");
if ($defcon) {
    $message = MSG_get_ui("swatch_memory_body_defcon_$defcon");
    $ball = $defcon_images{$defcon};
    
    my ($total,$free,$used,$percent);
    $total = $obj->get("total");
    $free = $obj->get("free");
    $used = $obj->get("used");
    $percent = $obj->get("percent");
    my $kb = MSG_get_ui("swatch_memory_kb");

    $info = sprintf "<BR><BR> %s <BR> %s <BR> %s <BR>\n",
		MSG_get_ui("swatch_memory_total", $total),
		MSG_get_ui("swatch_memory_free", $free),
		MSG_get_ui("swatch_memory_used", $used, $percent);
} else {
    $message = MSG_get_ui("swatch_body_defcon_0");
    $ball = $defcon_images{0};
}

if($q->param('alert')) {
    $back = "<A HREF=\"$alertScriptURL\"><IMG SRC=\"/.cobalt/images/back_but.gif\" BORDER=0></A>";
}
    
# Read in the template
open( TEMPLATE, "$Template_dir/memUsage.tmpl" )
    || die "Cannot read $Template_dir/memUsage.tmpl: $!\n";

print "content-type: text/html\nCache-Control: no-cache\n\n";

while ( <TEMPLATE> ) {
    s/\[DEFCON\]/$ball/o;
    s/\[MESSAGE\]/$message/o;
    s/\[INFO\]/$info/o;
    s/\[BACK\]/$back/o;

    s/\[str.([^\]]+)\]/Locale::gettext::dgettext("ui", "$1")/geo;

    print;
}

close TEMPLATE;


1;
