#!/usr/bin/perl

# Sendmail Control
# Copyright 1998 Cobalt Networks
# Jun 1998, Sept 1999 Will DeHaan <will@cobaltnet.com>
# 7/4/1999, Kevin K.M. Chiu kevin@cobaltnet.com (internationalization)

use Cobalt::Product;
use Cobalt::Locale;
use Cobalt::Services;
use Cobalt::Netutil;
use Cobalt::Email;
use Cobalt::Network;

use CGI;
#use strict;
use Locale::gettext;

my $locale=Cobalt::Locale->getByHTTPHeader( $ENV{ 'HTTP_ACCEPT_LANGUAGE' } );
if( $locale ) { $ENV{ 'LANGUAGE' }=$locale->getLocale(); }

# Parsin'
my($q) = new CGI;
my($WEB) = $q -> param('WEBUSAGE');
my($MAXEMAIL) = $q -> param('MAXEMAIL');
my($OLDMAXEMAIL) = $q -> param('OLDMAXEMAIL');
my($DS) = $q -> param('DS');
my($OLDDS) = $q -> param('OLDDS');
my(@RELAYUSER) = &enList( $q -> param('RELAYUSER') );
my(@OLDRELAYUSER) = &enList( $q -> param('OLDRELAYUSER') );
my(@RELAYSERVER) = &enList( $q -> param('RELAYSERVER') );
my(@OLDRELAYSERVER) = &enList( $q -> param('OLDRELAYSERVER') );
my(@CW) = &enList( $q -> param('CW') );
my(@OLDCW) = &enList( $q -> param('OLDCW') );
my(@CWSAVE) = &enList( $q -> param('CWSAVE') );
my(@SPAM) = &enList( $q -> param('SPAM') );
my(@OLDSPAM) = &enList( $q -> param('OLDSPAM') );

my($PopBeforeSmtpCGIInterval) = $q -> param('PBSMINUTES');
my($PopBeforeSmtpInterval) = '15';
my($PopBeforeSmtpPrevChecked) = $q -> param('POPBEFORESMTPCHECKED');
my($PopBeforeSmtpChecked);

my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
my($makemap) = "$MakeMap_cmd hash $MailDenyFile.db < $MailDenyFile";
my($iam) = $ENV{"SCRIPT_NAME"};
my($html_ERROR);

my $servicesScriptURL='/cgi-bin/.cobalt/services/services.cgi';

my($interval);

# $Template_dir/...
my(%templates) = (  
		 "EmailParam",		"$Template_dir/emailparam.tmpl",
		 );
# lets eleminate duplicates
my %relaykeys;
for(@RELAYUSER){
   $relaykeys{"$_"} = 1;
}
@RELAYUSER = keys %relaykeys;

my %serverkeys;
for(@RELAYSERVER){
   $serverkeys{"$_"} = 1;
}
@RELAYSERVER = keys %serverkeys;

my %cwkeys;
for(@CW){
   $cwkeys{"$_"} = 1;
}
@CW = keys %cwkeys;

my %spamkeys;
for(@SPAM){
   $spamkeys{"$_"} = 1;
}
@SPAM = keys %spamkeys;


#
#
# Begin main

if ($WEB) 
{
  $html_ERROR = &test_dataset; # Checks ALL new data
  $html_ERROR = &update_all unless ($html_ERROR);

  if( $html_ERROR ) {
    &fetch_data;
    &templatize('EmailParam');
  }
  else { print "location: $servicesScriptURL\n\n" }
}
else {
  &fetch_data;
  &templatize('EmailParam');
}

# Fin main
#
#

sub fetch_data
# Defines the all-caps globals
{
  # In megabytes..
  $MAXEMAIL = $OLDMAXEMAIL = int( mail_get_max_document()/1048576 );
  if( $MAXEMAIL==0 ) { $MAXEMAIL=''; }
 
  $DS = $OLDDS = mail_get_smart_relay();
 
  @OLDRELAYUSER = @RELAYUSER = mail_get_relay();
  
  if ($Features{'SERVER_RELAY'}) {
    open(SRV,"$MailRelayList");
    while(<SRV>) { chop; push(@RELAYUSER,$_); }
    close(SRV);
    @OLDRELAYSERVER = @RELAYSERVER;
  }
  
  @CW = mail_list_cw();
  my %email_routes = Cobalt::Email::mail_virtuser_list_route();
  my ($route);
  foreach $route (keys %email_routes) {
      @CW = grep { ! /^$route$/ } @CW;
      push @CWSAVE, $route;
  }
  @OLDCW = @CW;
  
  @OLDSPAM = @SPAM = mail_get_deny();

  if( -e '/usr/local/sbin/poprelayd' )  {
     open(POP, '/usr/local/sbin/poprelayd');
     while(<POP>) {
        if(/timeout_minutes = (\d+)\;/) {
           $PopBeforeSmtpInterval = $1;
            }
     }
     close(POP);
  }
  else {
     $PopBeforeSmtpInterval = '';
  }
  if( -e '/etc/cron.quarter-daily/poprelayd.custodiat' ) {
     $PopBeforeSmtpChecked = 'CHECKED' ;
  }
  else {
     $PopBeforeSmtpChecked = '' ;
  }  
  
}

sub test_dataset
# Uses all-caps globals
# builds error summary as all data is checked
{
  my($html_ERROR,$set,@testset,$elmnt,$ip_frag,$de_elmnt,$frag_cnt);

  # relayuser, relayserver need network and/or hosts
  @testset = ();
  foreach $elmnt (@RELAYUSER) { 
     if( $elmnt =~ /^[0-9\.]*$/ ) {
        $elmnt = Cobalt::Netutil::netutil_strip_ipaddr( $elmnt );
     }
     push(@testset, $elmnt);
  }
  @RELAYUSER = @testset;
  push(@testset,@RELAYSERVER);
  
  foreach $elmnt (@testset) {
    if( !Cobalt::Netutil::netutil_test_netaddr( $elmnt, 1 ) ) {
      $html_ERROR .= "".eval("\"".Locale::gettext::dgettext("ui", "notValidNetworkAddress")."\"")."<BR>";
    }
  }
  
  # sendmail.cw
  foreach $elmnt (@CW) {
    if( !Cobalt::Netutil::netutil_test_netaddr( $elmnt ) ) {
      $html_ERROR .= "".eval("\"".Locale::gettext::dgettext("ui", "notValidNetworkAddress")."\"")."<BR>";
    }
  }
  
  # Spammery
  @testset = ();
  foreach $elmnt (@SPAM) { 
     if( $elmnt =~ /^[0-9\.]*$/ ) {
        $elmnt = Cobalt::Netutil::netutil_strip_ipaddr( $elmnt );
     }
     push(@testset, $elmnt);
  }
  @SPAM = @testset;

  foreach $elmnt (@SPAM) {
    if ($elmnt =~ /\@/) { # We think it's an email address
      if( !Cobalt::Netutil::netutil_test_emailaddr( $elmnt ) ) {
      $html_ERROR .= "".eval("\"".Locale::gettext::dgettext("ui", "notValidNetworkAddress")."\"")."<BR>";
      }
    }
    elsif( !Cobalt::Netutil::netutil_test_netaddr( $elmnt ) ) {
      $html_ERROR .= "".eval("\"".Locale::gettext::dgettext("ui", "notValidNetworkAddress")."\"")."<BR>";
    }
  }
  
  # Max Message
  if( $MAXEMAIL ne '' ) {
    if( $MAXEMAIL!~/^\d*$/ || $MAXEMAIL==0 ) {
      $html_ERROR .= "".eval("\"".Locale::gettext::dgettext("ui", "maxDocumentSize")."\"")."<BR>";
    }
  }
  
  # Relay host 
  if( $DS ne '' ) {
    unless( Cobalt::Netutil::netutil_test_domainname($DS) ) {
      $html_ERROR .= "".eval("\"".Locale::gettext::dgettext("ui", "invalidSmartRelay")."\"")."<BR>";
    }
  }

  # POP Before SMTP Relaying:
  if( ($PopBeforeSmtpCGIInterval eq '') || ($PopBeforeSmtpCGIInterval < 1) ) {
      $html_ERROR .= "".eval("\"".Locale::gettext::dgettext("ui", "PopBeforeSmtpIntervalWrong")."\"")."<BR>";
  }
  
  return($html_ERROR);
}


sub update_all
{
  my $ret;
  
  # Max document size
  if ($MAXEMAIL eq '') {
      $MAXEMAIL=0;
  }
  if ($MAXEMAIL != $OLDMAXEMAIL) {
      $ret = mail_set_max_document(int($MAXEMAIL)*1048576);
      $OLDMAXEMAIL = $MAXEMAIL;  # reset diff
      return($1) if ($ret =~ /^4\d\d\d(.*)/);
  }
 
  # "Smart" relay 
  if ($DS ne $OLDDS) {
      $ret = mail_set_smart_relay($DS);
      $OLDDS = $DS; 
      return($1) if ($ret =~ /^4\d\d\d(.*)/);
  }
  
  # SPAM
  if (join(' ',@SPAM) ne join(' ',@OLDSPAM)) {
      $ret = mail_set_deny(@SPAM);
      @OLDSPAM = @SPAM;
      return($1) if ($ret !~ /^2/);
  }
  
  # User relay 
  if (join(' ',@RELAYUSER) ne join(' ',@OLDRELAYUSER)) {
      $ret = mail_del_relay(@OLDRELAYUSER);
      return($1) if ($ret !~ /^2/);
      $ret = mail_add_relay(@RELAYUSER);
      return($1) if ($ret !~ /^2/);
      @OLDRELAYUSER = @RELAYUSER;
  }
  
  # Server relay
  if (join(' ',@RELAYSERVER) ne join(' ',@OLDRELAYSERVER)) {
      &array2flat($MailRelayList,@RELAYSERVER);
      @OLDRELAYSERVER = @RELAYSERVER;
  }
  
  # sendmail.cw
  if (join(' ',@CW) ne join(' ',@OLDCW)) {
      push (@CW, @CWSAVE);
      my %diff = map { $_, 1 } @CW;
      @CW = keys %diff;
      &array2flat($Sendmail_cw,@CW);
      @OLDCW = @CW;
  }

  # POP Before SMTP Relaying:
  if($PopBeforeSmtpPrevChecked=~/ON/o) {
     Cobalt::Email::mail_pop_before_smtp_enable;
  }
  else {
     Cobalt::Email::mail_pop_before_smtp_disable;
  }

  Cobalt::Email::mail_pop_before_smtp_set_interval( $PopBeforeSmtpCGIInterval );
  
  Cobalt::Email::mail_sendmail_hup();
  
  return 0;
}


sub enList
# Takes a messy user input string and filters/sorts it into an array
{
	my($dataset) = $_[0];
	$dataset =~ s/[\n\r\t\,\;\:]/ /og;
	$dataset =~ s/^\s+//og;
	return ( sort( split(/\s+/,$dataset) ) );
}


sub templatize {
	my($template) = $_[0];
	$template = $templates{"$template"};

	if ($html_ERROR =~ /\w/) { # Error pre-formatting
	    # error is returned in a table to support multi-line errors
	    $html_ERROR = '<IMG SRC="/.cobalt/images/bang.gif" ALIGN=CENTER>' . $html_ERROR;
	    $html_ERROR =~ s/[\n\r]//g;
	}

	# html likes strings, boring
	my($RELAYUSER) = join("\n",sort(@RELAYUSER));
	my($OLDRELAYUSER) = join("\n",@OLDRELAYUSER);
	my($RELAYSERVER) = join("\n",@RELAYSERVER);
	my($OLDRELAYSERVER) = join("\n",@OLDRELAYSERVER);
	my($CW) = join("\n",sort(@CW));
	my($OLDCW) = join("\n",@OLDCW);
	my($CWSAVE) = join("\n",@CWSAVE);
	my($SPAM) = join("\n",sort(@SPAM));
	my($OLDSPAM) = join("\n",@OLDSPAM);

	my($domain) = (Cobalt::Network::net_get_dnsclient())[0];

	print "Content-type: text/html\nCache-Control: no-cache\n\n";
#	print "$html_ERROR";
	if (-e "$template") {
		open(TMPL,"$template");
		while(<TMPL>) {
			s/\[IAM\]/$iam/og;
			s/\[MAXEMAIL\]/$MAXEMAIL/og;
			s/\[OLDMAXEMAIL\]/$OLDMAXEMAIL/og;
			s/\[DS\]/$DS/og;
			s/\[OLDDS\]/$OLDDS/og;
			s/\[RELAYUSER\]/$RELAYUSER/og;
			s/\[OLDRELAYUSER\]/$OLDRELAYUSER/og;
			s/\[RELAYSERVER\]/$RELAYSERVER/og;
			s/\[OLDRELAYSERVER\]/$OLDRELAYSERVER/og;
			s/\[CW\]/$CW/og;
			s/\[OLDCW\]/$OLDCW/og;
			s/\[CWSAVE\]/$CWSAVE/og;
			s/\[SPAM\]/$SPAM/o;
			s/\[OLDSPAM\]/$OLDSPAM/o;
			s/\[DOMAIN\]/$domain/o;
			s/\[SHOWINFO\]/$html_ERROR/o;

         s/\[POPBEFORESMTPCHECKED\]/$PopBeforeSmtpChecked/o;
         s/\[POPBEFORESMTPINTERVAL\]/$PopBeforeSmtpInterval/o;

			s/\[str.([^\]]+)\]/Locale::gettext::dgettext("ui", "$1")/geo;

			print;
		}
	} else {
		# Ack! No template
	  print "Ack! No template";
	}
}


sub array2flat {
        my($file,@data) = @_;
	my($data);

        open(OUTFL,"> $file") || die "Can't write file: $!";
        foreach $data (@data) {
                print OUTFL "$data\n" if ($data =~ /\S/);
        }
        close(OUTFL);
}

	
# No return value
sub dump_relay {
        my(@list) = @_;
        # No need to filter/test data at this point

        my($net,@netlist,%nets);
        my(@domlist,%domains);

        foreach $net (@list) {
                if ($net =~ /[a-zA-Z]/) {
                        # Domain
                        push(@domlist,$net) unless ($domains{"$net"});
                        $domains{"$net"} = 1;
                } else {
                        # IP net or nul
			push(@netlist,$net) unless (($net !~ /\w/) || $nets{"$net"});
                        $nets{"$net"} = 1;
                }
        }

	&array2flat($MailIPList,@netlist);
	&array2flat($MailNameList,@domlist);
}
