#!/usr/bin/perl

# Parse/Concatonate access logs
#
# Harris Vaegan-Lloud <harris@cobaltnet.com>
# Kevin <kevin@cobaltnet.com>
#
# Copyright 1999, Cobalt Networks, Inc
# All rights reserved

use Cobalt::Product;
use Cobalt::Group;
use Cobalt::Vsite;
use Cobalt::User;

#use strict;
use CGI;

# global variables
my $q=new CGI;

my $group=$q->param( 'group' );
my $type=$q->param( 'service' );

my $forbiddenURL="/.cobalt/error/forbidden.html";
my $logFile;

if ( $group ) {
	$logFile="$Htgroup_dir/$group/$Logdir/$type.log";
} else {
	# For the whole RaQ.
	if ( $type eq 'mail' ) {
		$logFile=$Mail_log;
	} elsif ( $type eq 'ftp' ) {
		$logFile=$FTP_log;
	} elsif ( $type eq 'web' ) {
		$logFile=$Access_log;
	}
}

# Add some remote hint of security here 
my $user = $ENV{REMOTE_USER};
unless (user_authok($user, "group", $group)) {
    print "location: $forbiddenURL\n\n";    
    die "Unauthorised access by $user, not a member of $group.\n";
}

# Test the authenticated user against the site admin list 
my($siteAdmin,%member);
my(@siteAdmins)=group_show($group);
foreach $siteAdmin (@siteAdmins) { $member{$siteAdmin}=1; }

# find site hostname
my($host)=(vsite_get_bygroup($group))[1];

print STDERR "Host: $host Group: $group\n" if $Debug;

$host ||= 'raqwide';


die "Unauthorized $host web log download attempt by user ".
    $ENV{'REMOTE_USER'}.' '.$ENV{'REMOTE_HOST'} unless
    ($member{ $ENV{'REMOTE_USER'} } || ($ENV{'REMOTE_USER'} eq $Adminuser));

# IE 4 tries to display standard binary mime types.
# print "Content-type: application/octet-stream\n";
print "Content-type: application/UnknownWebLog\n";
print "Content-disposition: filename=$host.$type.log\n\n";

# First read the fragmented log file, then parse the to-the-minute entries 
# from the consolidated access log if this is a web log. Otherwise don't
# bother. Note that we miss the compressed logs, if people care enough they
# can get them via ftp.

my($foundLog)=0;

# Just for web we grab up to date entires from the access file.
# Skip this bit for tha mian group as we grab all of this anyways.
if($type eq 'web' && $group) {
    open(AXL,"$Access_log");
    while(<AXL>) {
        if ($_ =~ /^(\S+) (.*)/) {
            if ($1 eq $host) {
                print $2."\n";
                $foundLog=1;
	    	}
		}
    }
    close(AXL);
}

my $i;

my $current_logFile = $logFile;

while (-r $current_logFile) {
	print STDERR "Now grabbing $current_logFile\n" if $Debug;
    open(LGZ,$current_logFile);
    while (<LGZ>) {
		print;
		# Moved here to make sure that we don't think we've got
		# data when we just have an empty file.
    	$foundLog=1;
	}
    close(LGZ);
	$i++;
	# Now we grab all the .<number> files that logrotate cataches as
	# well.
	$current_logFile = $logFile . ".$i";
}


# Null files are bad
print "0\n" unless ($foundLog);

# R.E.M. kick ass.
