// Author: Kevin K.M. Chiu
// Version: 1.0
// Date: 7-10-98
// Copyright 1998-1999, Cobalt Networks.  All rights reserved.

function isDiskQuotaValid( diskQuota ) { 
    if( diskQuota=='0' ) return false; 
    else { 
        for( i=0; i<diskQuota.length; i++ ) { 
            var ch=diskQuota.charAt( i ); 
            if( ch<'0' || ch>'9' ) return false; 
        } 
    } 
    return true; 
}

function checkDiskQuota( element, errMsg ) { 
    if( element.value.length>0 && !isDiskQuotaValid( element.value ) ) {
	top.showInfo( errMsg );
        element.focus();
        element.select();
        return false;
    }
    return true;
}

function isIntegerValid( integer ) { 
    for( i=0; i<integer.length; i++ ) { 
        var ch=integer.charAt( i ); 
        if( ch<'0' || ch>'9' ) return false; 
    } 

    return true; 
}

function checkInteger( element, errMsg ) { 
    if( element.value.length>0 && !isIntegerValid( element.value ) ) {
	top.showInfo( errMsg );
        element.focus();
        element.select();
        return false;
    }
    return true;
}